;================================================
;	POCKET DUNGEON
;	ver 1.00
;	for XASM32 1.4x
;	2006.04-
;	by choikyun
;================================================



	org	0bbc00h
	scope_on
	pre_off
	include DEF.INC
	include	DEFGAME.S



;================================================
;	CODE
;================================================
	pushu	imr

	pre	32h
	mv	[--u],(0ech)
	pre	32h
	mv	(0ech),0

	mv	(save_sp),s		;X^bN|C^ۑ

	mv	il,4
	sbcl	(bx),(bx)
	mv	a,[(0e6h)+8]
	mv	il,048h
	call	IocsCall		;\JnCZbg
	call	Cls

;	call	Print_HISCORE
	call	LoadData		;Ȏ[h
	cmp	[SaveFlg],1
	jrz	Main

	call	Credit			;҃NWbg



	;e평
	mv	(sound),1
Init:
	call	InitValue		;eϐ
	call	InitPlayer		;vC[ϐ



Start:
	call	MakeNewDungeon		;_W쐬
	call	initScreenPos		;XN[\ʒu

	call	Ready



	;C[`
Main:
 {
	call	Inkey			;L[ǂݏo
	call	Inkey2

	call	ClearScreen		;XN[obt@NA

	call	MovePlayer		;vC[ړ
	call	ShotArrow		;˂
	call	DashPlayer		;vC[
	call	LightPassage		;ʘH̓_
	call	VisitRoom		;̓_
	call	Monster			;X^[
	call	HouseMons		;X^[nEX
	{
		cmp	(return_flg),0
		jrz	break
		call	Monster		;X^[ړ{
		call	HouseMons
	}
	call	Recovery		;ŏ
	call	MapToScreen		;XN[ɕ`
	call	CheckItem		;ACe̔
	call	CheckTrap		;gbv̔
	call	Hungry			;
	call	Limit			;nkJEg
	call	GameOver		;Q[I[o[
	call	DispScreen		;XN[\

	call	DispMiniMap		;k}bv[h
	call	ChangeSe		;ʉ؂芷
	test	(key),KEY_BASIC
	jrz	continue
 }



	;I
Basic:
	call	SaveData		;Q[is̕ۑ

	mv	s,(save_sp)		;X^bN|C^A
	and	[SCRN_CSR_Y],0		;sZbg

	call	Cls
	call	VerInfo			;o[W\
	pre	32h
	mv	(0ech),[u++]
	popu	imr
	rc
	retf



;------------------------------------------------
;	eϐ
;------------------------------------------------
InitValue:
 {
	mv	(keyf),0
	mv	(keyf2),0

	mv	(hp_count),DEF_HP_COUNT		;HPR񕜃JEg
	mv	(hung_count),DEF_HUNG_COUNT	;󕠃JEg

	mv	(key_wait),1			;L[EFCg
	mv	(floor),1			;K
	mv	(stop_count),0			;ړsJEg

	mv	(game_status),0			;Q[I[o[tO
	mv	(return_flg),0			;A҃tO
	ret
 }



;------------------------------------------------
;	vC[
;------------------------------------------------
InitPlayer:
 {
	call	InitStatus		;vC[Xe[^X
	ret
 }



	;Xe[^X
InitStatus:
 {
	mv	(level),1		;x
	mv	(hp_max),16		;qbg|Cg
	mv	(hp),(hp_max)
	mv	(base_str),2		;{U
	mv	(base_arm),2		;{h
	mv	(str),0			;U
	mv	(arm),0			;hh
	mvw	(gold),0		;
	mvw	(expe),0		;ol
	mvw	(next_expe),10		;̃x܂ł̌ol
	mv	(p_status),ST_NOMAL	;vC[̏ԁFm[}
	mv	(hung),100		;xF100%
	mv	(hung_max),100		;ő喞xF100%
	mv	(arrow),0		;|
	mv	(revival_flg),0		;tO

	jp	Print_ALLSTATUS
 }



	;Tu@vC[W
InitPosition:
 {
	call	MixRoomNum		;ԍ̃Vbt

	mv	x,RoomNumData
	{
		mv	(work),[x++]	;߂
		call	GetRoomPointer

		mv	a,[y]
		test	a,R_ROOM
		jrz	continue
	}
	mv	(current_room),(work)	;݂̕

	mvw	(work+0),[y+1]		;Xn_,I_
	mvw	(work+2),[y+3]		;Yn_,I_
	inc	(work)
	inc	(work+2)
	{
		call	Rnd
		and	(vrnd),15
		mv	a,(work)
		add	(vrnd),a
		cmp	(vrnd),(work+1)	;X
		jrnc	continue
	}
	mv	(my_x),(vrnd)
	{
		call	Rnd
		and	(vrnd),7
		mv	a,(work+2)
		add	(vrnd),a
		cmp	(vrnd),(work+3)	;Y
		jrnc	continue
	}
	mv	(my_y),(vrnd)

	mvw	(work),(my_x)	;X^[ƏdȂȂ
	call	GetMapPos
	mv	a,[x]
	and	a,FLG_LIGHT
	cmp	a,MARK_S
	jrnc	InitPosition

	mv	(work),(current_room)
	call	LightRoom
	ret
 }



;------------------------------------------------
;	XN[\ʒu
;------------------------------------------------
InitScreenPos:
 {
	mvw	(scrn_x),0

	mv	a,(my_x)	;X
	{
		sub	a,10
		jrnc	break
		mv	a,0
	}
	add	(scrn_x),a
	{
		cmp	(scrn_x),MAP_WIDTH-20-1-1
		jrc	break
		mv	(scrn_x),MAP_WIDTH-20-1-1
	}
	mv	a,(my_y)	;Y
	{
		sub	a,2
		jrnc	break
		mv	a,0
	}
	add	(scrn_y),a
	{
		cmp	(scrn_y),MAP_HEIGHT-5-1
		jrc	break
		mv	(scrn_y),MAP_HEIGHT-5-1
	}
	ret
 }



;------------------------------------------------
;	Q[Jn
;------------------------------------------------
Ready:
 {
	mv	(flash),1
	call	DispStatus
	{
		cmp	(return_flg),0
		jrz	break
		ret
	}
	{
		cmp	(floor),1
		jrz	break
		ret
	}
	jp	Print_UNMEI	;^̓Aւ悤
 }



;------------------------------------------------
;	ʉ؂芷
;------------------------------------------------
ChangeSe:
 {
	{
		test	(keyf),KEY_CCE
		jrz	break

		xor	(sound),1

		mv	(sound_no),1
		call	Se

		mv	x,Icon_Se
		mv	a,(sound)
		swap	a
		ror	a
		add	x,a
		mv	y,Bg_STATUS+SCREEN_WIDTH*3+114
		mv	il,5
		mvl	(work),[x+0]
		mv	il,5
		mvl	[y+0],(work)

		mv	(flash),ON
		call	DispStatus
	}
	ret
 }



;------------------------------------------------
;	Q[I
;------------------------------------------------
GameOver:
 {
	{
		cmp	(game_status),0
		jrnz	break
		ret
	}
	{
		cmp	(revival_flg),0
		jrz	break

		mv	(sound_no),2
		call	Se
		mv	(hp),(hp_max)		;
		mv	(hung),(hung_max)
		mv	(p_status),ST_NOMAL
		mv	(revival_flg),0
		mv	(game_status),0
		call	Print_REVIVAL
		ret
	}
	call	InitMap

	test	(game_status),GO_CLEAR
	jrnz	Clear

	mvw	(work),(my_x)
	call	GetMapPos
	mv	a,MARK_GRAVE		;W
	mv	[x],a
	mv	a,MARK_FLOWER		;ԁH
	mv	[x-MAP_WIDTH-1],a
	mv	[x-MAP_WIDTH],a
	mv	[x-MAP_WIDTH+1],a
	mv	[x-1],a
	mv	[x+1],a
	mv	[x+MAP_WIDTH-1],a
	mv	[x+MAP_WIDTH],a
	mv	[x+MAP_WIDTH+1],a

	mv	(flash),1
	call	DispStatus
	mv	(sound_no),3
	call	Se
	{
		test	(game_status),GO_MONS
		jrz	break
		call	Print_OVER_1
	}
	{
		test	(game_status),GO_HUNG
		jrz	break
		call	Print_OVER_2
	}
	{
		test	(game_status),GO_TRAP
		jrz	break
		call	Print_OVER_3
	}
	{
		test	(game_status),GO_PAN
		jrz	break
		call	Print_OVER_4
	}
	{
		test	(game_status),GO_POISON
		jrz	break
		call	Print_OVER_5
	}
	{
		test	(game_status),GO_FLAME
		jrz	break
		call	Print_OVER_6
	}
_next:
	call	CmpScore
	call	Print_HISCORE		;nCXRA
	mv	(flash),1
	call	DispStatus

	call	ClearMessage
	call	Print_HITKEY
	{
		call	Inkey
		call	Inkey2
		call	DispScreen

		test	(key),KEY_BASIC
		jpnz	Basic
		or	(keyf),(keyf2)
		test	(keyf),1111_1111b
		jrz	continue
	}
	pops	i
	jp	Init


	;Tu@NA
Clear:
	call	PutPlayer
	call	Print_CLEAR	;bZ[W
	jr	_next
 }



;------------------------------------------------
;	R
;------------------------------------------------
Recovery:
 {
	{
		cmp	(turn_end),0
		jrnz	break
		ret
	}
	{
		dec	(hp_count)
		jrz	break
		ret
	}
	{
		cmp	(hp),0
		jrnz	break
		ret
	}
	mv	(hp_count),DEF_HP_COUNT
	{
		cmp	(p_status),ST_NOMAL	;łƉ񕜂
		jrz	break
		mv	(hp_count),DEF_HP_COUNT*2
	}
	inc	(hp)
	{
		cmp	(hp_max),(hp)
		jrnc	break
		mv	(hp),(hp_max)
	}
	call	Print_HP
	mv	(flash),1
	jp	DispStatus
 }



;------------------------------------------------
;	󕠃JEg
;------------------------------------------------
Hungry:
 {
	{
		cmp	(turn_end),0
		jrnz	break
		ret
	}
	{
		dec	(hung_count)
		jrz	break
		ret
	}
	mv	(hung_count),DEF_HUNG_COUNT
	{
		cmp	(revival_flg),0	;wւ͕肪Ȃ
		jrz	break
		sub	(hung_count),2
	}
	{
		sub	(hung),1
		jrnc	break
		mv	(hung),0
	}
	{
		cmp	(hung),0
		jrnz	break
		mv	(game_status),GO_HUNG	;쎀
	}
	{
		cmp	(hung),8
		jrnc	break
		call	Print_HUNGRY
	}
	call	Print_HUNG
	mv	(flash),1
	jp	DispStatus
 }



;------------------------------------------------
;	nkJEg
;------------------------------------------------
Limit:
 {
	{
		cmp	(turn_end),0
		jrnz	break
		ret
	}
	{
		{
			mv	ba,50
			cmpw	(limit_count),ba
			jrnz	break
			call	Print_SHAKE	;xbZ[W
		}
		mv	ba,(limit_count)
		dec	ba
		mv	(limit_count),ba
		jrz	break
		ret
	}
	call	Print_HOLE	;Ƃ
	call	SetNextFloor
	call	Print_FLOOR
	call	Print_HP

	pops	i
	jp	Start
 }



;------------------------------------------------
;	k}bv[h
;------------------------------------------------
DispMiniMap:
 {
	{
		test	(keyf),KEY_SHIFT
		jrnz	break
		ret
	}
	call	ClearScreen
	call	DrawMiniMap
	call	Print_HITKEY
	{
		call	Inkey
		call	Inkey2
		call	DispScreen

		test	(keyf),KEY_BASIC
		jpnz	Basic
		or	(keyf),(keyf2)
		test	(keyf),1111_1111b
		jrz	continue
	}
	jp	InitScreenPos
 }



	;Tu@k}bv`
DrawMiniMap:
 {
	mv	x,FieldMap
	mv	(SI),1
	{
		mv	(DI),28
		{
			mv	a,[x++]
			and	a,1011_1111b
			cmp	a,0
			jrz	_next
			cmp	a,6
			jrnc	_next

			mv	a,(SI)
			mv	b,a
			mv	a,(DI)
			mv	y,ScreenBuf
			call	Pset
_next:
			inc	(DI)
			cmp	(DI),MAP_WIDTH+28
			jrnz	continue
		}
		mv	(DI),0
		inc	(SI)
		cmp	(SI),31
		jrnz	continue
	}
	ret
 }



;------------------------------------------------
;	vC[
;------------------------------------------------
DashPlayer:
 {
	{
		test	(key),KEY_SPACE
		jrnz	break
		ret
	}
	mv	(key_wait),1
	ret
 }



;------------------------------------------------
;	vC[ړ
;------------------------------------------------
MovePlayer:
 {
	mv	(turn_end),0
	{
		dec	(key_wait)
		jrz	break
		ret
	}
	call	ErasePlayer
	mv	(key_wait),1
	{
		test	(key2),KEY_5	;̏ŉ񕜁{㩂𒲂ׂ
		jrz	break

		call	PutPlayer
		call	SearchTrap
		inc	(turn_end)
		mv	(key_wait),1
		ret
	}
	{
		test	(key),KEY_8	;UP
		jrz	break

		mvw	(work),(my_x)
		dec	(work+1)	;y-1
		call	CheckWall	;Q`FbN
		jrc	break
		dec	(my_y)

		inc	(turn_end)
		call	SetKeyWait	;L[EFCg
		jp	PutPlayer
	}
	{
		test	(key),KEY_2	;DOWN
		jrz	break

		mvw	(work),(my_x)
		inc	(work+1)	;y+1
		call	CheckWall	;Q`FbN
		jrc	break
		inc	(my_y)

		inc	(turn_end)
		call	SetKeyWait	;L[EFCg
		jp	PutPlayer
	}
	{
		test	(key),KEY_6	;RIGHT
		jrz	break

		mvw	(work),(my_x)
		inc	(work)		;x+1
		call	CheckWall	;Q`FbN
		jrc	break
		inc	(my_x)

		inc	(turn_end)
		call	SetKeyWait	;L[EFCg
		jr	PutPlayer
	}
	{
		test	(key),KEY_4	;LEFT
		jrz	break

		mvw	(work),(my_x)
		dec	(work)		;x-1
		call	CheckWall	;Q`FbN
		jrc	break
		dec	(my_x)

		inc	(turn_end)
		call	SetKeyWait	;L[EFCg
		jr	PutPlayer
	}
	{
		cmp	(back_mark),MARK_PASSAGE+1;hAAʘHł͎΂߈ړȂ
		jrc	break

		test	(key2),KEY_1	;
		jrz	break

		mvw	(work),(my_x)
		dec	(work)		;x-1
		inc	(work+1)	;y+1
		call	CheckWall	;Q`FbN
		jrc	break
		cmp	a,-1		;΂߂ɓȂ
		jrz	break
		dec	(my_x)
		inc	(my_y)

		inc	(turn_end)
		call	SetKeyWait	;L[EFCg
		jr	PutPlayer
	}
	{
		cmp	(back_mark),MARK_PASSAGE+1;hAAʘHł͎΂߈ړȂ
		jrc	break

		test	(key2),KEY_7	;
		jrz	break

		mvw	(work),(my_x)
		dec	(work)		;x-1
		dec	(work+1)	;y-1
		call	CheckWall	;Q`FbN
		jrc	break
		cmp	a,-1		;΂߂ɓȂ
		jrz	break
		dec	(my_x)
		dec	(my_y)

		inc	(turn_end)
		call	SetKeyWait	;L[EFCg
		jr	PutPlayer
	}
	{
		cmp	(back_mark),MARK_PASSAGE+1;hAAʘHł͎΂߈ړȂ
		jrc	break

		test	(key2),KEY_3	;E
		jrz	break

		mvw	(work),(my_x)
		inc	(work)		;x+1
		inc	(work+1)	;y+1
		call	CheckWall	;Q`FbN
		jrc	break
		cmp	a,-1		;΂߂ɓȂ
		jrz	break
		inc	(my_x)
		inc	(my_y)

		inc	(turn_end)
		call	SetKeyWait	;L[EFCg
		jr	PutPlayer
	}
	{
		cmp	(back_mark),MARK_PASSAGE+1;hAAʘHł͎΂߈ړȂ
		jrc	break

		test	(key2),KEY_9	;E
		jrz	break

		mvw	(work),(my_x)
		inc	(work)		;x+1
		dec	(work+1)	;y-1
		call	CheckWall	;Q`FbN
		jrc	break
		cmp	a,-1		;΂߂ɓȂ
		jrz	break
		inc	(my_x)
		dec	(my_y)

		inc	(turn_end)
		call	SetKeyWait	;L[EFCg
	}
 }



;------------------------------------------------
;	vC[}bvɏ
;------------------------------------------------
PutPlayer:
 {
	pushu_reg
	call	InitScreenPos	;XN[ʒu␳

	mvw	(work),(my_x)
	call	GetMapPos

	mv	(back_mark),[x]
	mv	a,MARK_PLAYER
	mv	[x],a
	popu_reg
	ret
 }



;------------------------------------------------
;	vC[
;------------------------------------------------
ErasePlayer:
 {
	mvw	(work),(my_x)
	call	GetMapPos

	mv	[x],(back_mark)
	ret
 }



;------------------------------------------------
;	Q`FbN
;	in:	(work).w	XYW
;	out:	Cy=1		Q
;		a=-1		hA
;------------------------------------------------
CheckWall:
 {
	call	GetMapPos
	mv	a,[x]
	{
		cmp	a,MARK_SPACE
		jrnz	break
		sc
		ret
	}
	{
		cmp	a,MARK_WALL_C
		jrnz	break
		sc
		ret
	}
	{
		cmp	a,MARK_WALL_R
		jrnz	break
		sc
		ret
	}
	{
		test	a,FLG_DARK
		jrz	break
		sc
		ret
	}
	{
		test	a,FLG_HIDEDOOR	;B
		jrz	break
		mv	a,MARK_DOOR
		mv	[x],a
		rc
		ret
	}
	{
		test	a,FLG_TRAP	;gbv
		jrz	break
		rc
		ret
	}
	{
		cmp	a,MARK_S	;X^[
		jrc	break
		call	Attack_M	;U
		sc
		ret
	}
	{
		cmp	a,MARK_DOOR	;
		jrnz	break
		mv	a,-1
	}
	rc
	ret
 }



;------------------------------------------------
;	𒲂ׂ
;------------------------------------------------
SearchTrap:
 {
	mvw	(work),(my_x)
	call	GetMapPos
	rc
	{
		mv	a,[x-MAP_WIDTH-1]
		test	a,FLG_TRAP
		jrz	break
		and	a,1101_1111b
		mv	[x-MAP_WIDTH-1],a	;gbv
		sc
	}
	{
		mv	a,[x-MAP_WIDTH]
		test	a,FLG_TRAP
		jrz	break
		and	a,1101_1111b
		mv	[x-MAP_WIDTH],a
		sc
	}
	{
		mv	a,[x-MAP_WIDTH+1]
		test	a,FLG_TRAP
		jrz	break
		and	a,1101_1111b
		mv	[x-MAP_WIDTH+1],a
		sc
	}
	{
		mv	a,[x-1]
		test	a,FLG_TRAP
		jrz	break
		and	a,1101_1111b
		mv	[x-1],a
		sc
	}
	{
		mv	a,[x+1]
		test	a,FLG_TRAP
		jrz	break
		and	a,1101_1111b
		mv	[x+1],a
		sc
	}
	{
		mv	a,[x+MAP_WIDTH-1]
		test	a,FLG_TRAP
		jrz	break
		and	a,1101_1111b
		mv	[x+MAP_WIDTH-1],a
		sc
	}
	{
		mv	a,[x+MAP_WIDTH]
		test	a,FLG_TRAP
		jrz	break
		and	a,1101_1111b
		mv	[x+MAP_WIDTH],a
		sc
	}
	{
		mv	a,[x+MAP_WIDTH+1]
		test	a,FLG_TRAP
		jrz	break
		and	a,1101_1111b
		mv	[x+MAP_WIDTH+1],a
		sc
	}
	{
		jrnc	break
		call	Print_FOUNDTRAP	;bZ[W
	}
	ret
 }



;------------------------------------------------
;	˂
;------------------------------------------------
ShotArrow:
 {
	{
		cmp	(turn_end),0
		jrz	break
		ret
	}
	{
		test	(keyf2),KEY_0
		jrnz	break
		ret
	}
	{
		cmp	(arrow),0
		jrnz	break
		ret
	}
	mv	(sound_no),2
	call	Se
	{
		call	Inkey
		call	Inkey2
		call	Print_SET_ARROW	;bZ[W
		call	DispScreen
		test	(keyf2),KEY_0	;LZ
		jrnz	break
		{
			test	(keyf2),KEY_1
			jrz	break
			mvw	(work+5),01ffh	;-1,1
			call	Attack_ARROW
			jr	_return
		}
		{
			test	(keyf),KEY_2
			jrz	break
			mvw	(work+5),0100h	;0,1
			call	Attack_ARROW
			jr	_return
		}
		{
			test	(keyf2),KEY_3
			jrz	break
			mvw	(work+5),0101h	;1,1
			call	Attack_ARROW
			jr	_return
		}
		{
			test	(keyf),KEY_4
			jrz	break
			mvw	(work+5),00ffh	;-1,0
			call	Attack_ARROW
			jr	_return
		}
		{
			test	(keyf),KEY_6
			jrz	break
			mvw	(work+5),0001h	;1,0
			call	Attack_ARROW
			jr	_return
		}
		{
			test	(keyf2),KEY_7
			jrz	break
			mvw	(work+5),0ffffh	;-1,-1
			call	Attack_ARROW
			jr	_return
		}
		{
			test	(keyf),KEY_8
			jrz	break
			mvw	(work+5),0ff00h	;0,-1
			call	Attack_ARROW
			jr	_return
		}
		{
			test	(keyf2),KEY_9
			jrz	break
			mvw	(work+5),0ff01h	;1,-1
			call	Attack_ARROW
			jr	_return
		}
		jr	continue
	}
_return:
	mv	(turn_end),2
	ret
 }


;------------------------------------------------
;	|̍U
;	in:	(work+5).w	ړ@XY
;------------------------------------------------
Attack_ARROW:
 {
	mv	(sound_no),2
	call	Se

	call	Print_SHOT_ARROW
	dec	(arrow)
	call	Print_ARROW_ST
	mv	(flash),1
	call	DispStatus

	mv	y,MonBuf		;X^[\	
	mv	(work+10),MAX_MONS_NUM
	call	ShowMonster
	{
		cmp	(m_house_flg),0	;X^[nEX邩
		jrz	break
		mv	y,HouseBuf
		mv	(work+10),MAX_HOUSE_NUM
		call	ShowMonster
	}
	mvw	(work),(my_x)
	mv	il,DEF_ARROW_RANGE	;˒
	{
		mv	ba,(work+5)
		add	(work),a
		mv	a,b
		add	(work+1),a
		call	GetMapPos
		mv	a,[x]
		test	a,FLG_HIDEDOOR	;B
		jrnz	break
		and	a,0001_1111b

		cmp	a,MARK_WALL_R+1	;ǁA
		jrc	break

		cmp	a,MARK_S	;X^[
		jrnc	_Hit_ARROW
		dec	il
		jrnz	continue
	}
	mv	y,MonBuf		;X^[B	
	mv	(work+10),MAX_MONS_NUM
	call	HideMonster
	{
		cmp	(m_house_flg),0
		jrz	break
		mv	y,HouseBuf
		mv	(work+10),MAX_HOUSE_NUM
		call	HideMonster
	}
	ret


_Hit_ARROW:
	pushu	a
	mvw	[--u],(work)
	mv	y,MonBuf		;X^[B	
	mv	(work+10),MAX_MONS_NUM
	call	HideMonster
	{
		cmp	(m_house_flg),0
		jrz	break
		mv	y,HouseBuf
		mv	(work+10),MAX_HOUSE_NUM
		call	HideMonster
	}
	mvw	(work),[u++]
	popu	a

	call	Search_MONSTER
	pushu	x

	mv	(m_status),ST_NOMAL	;ڂo܂
	mv	a,1
	mv	(sound_no),0
	{
		call	Rnd
		and	(vrnd),3
		jrz	break

		sub	(m_hp),4
		mv	a,0
		mv	(sound_no),2
	}
	call	Se
	call	Print_ATTACK_P		;bZ[W
	call	MakeNewMonster

	popu	x
	mv	il,11
	mvl	[x+0],(m_name)
	ret
 }



;------------------------------------------------
;	L[EFCgZbg
;------------------------------------------------
SetKeyWait:
 {
	{
		cmp	(back_mark),MARK_FLOOR
		jrnz	break
		mv	(key_wait),2
		ret
	}
	mv	(key_wait),4
	ret
 }



;------------------------------------------------
;	ʘHCgAbv{
;------------------------------------------------
LightPassage:
 {
	{
		cmp	(turn_end),0
		jrnz	break
		ret
	}
	mvw	(work),(my_x)
	call	GetMapPos
	{
		cmp	(back_mark),MARK_PASSAGE+1	;ʘHAhAH
		jrnc	break
		{
			mv	a,[x-1]
			cmp	a,MARK_WALL_C|FLG_DARK	;
			jrz	break
			cmp	a,MARK_WALL_R|FLG_DARK	;
			jrz	break
			and	a,FLG_LIGHT	;SCgAbv
			mv	[x-1],a
			{
				cmp	a,MARK_DOOR	;hAȂ
				jrnz	break
				mv	(work),(current_room)
				call	MaskRoom	;}XN
			}
		}
		{
			mv	a,[x+1]
			cmp	a,MARK_WALL_C|FLG_DARK
			jrz	break
			cmp	a,MARK_WALL_R|FLG_DARK
			jrz	break
			and	a,FLG_LIGHT
			mv	[x+1],a
			{
				cmp	a,MARK_DOOR
				jrnz	break
				mv	(work),(current_room)
				call	MaskRoom
			}
		}
		{
			mv	a,[x-MAP_WIDTH]
			cmp	a,MARK_WALL_C|FLG_DARK
			jrz	break
			cmp	a,MARK_WALL_R|FLG_DARK
			jrz	break
			and	a,FLG_LIGHT
			mv	[x-MAP_WIDTH],a
			{
				cmp	a,MARK_DOOR
				jrnz	break
				mv	(work),(current_room)
				call	MaskRoom
			}
		}
		{
			mv	a,[x+MAP_WIDTH]
			cmp	a,MARK_WALL_C|FLG_DARK
			jrz	break
			cmp	a,MARK_WALL_R|FLG_DARK
			jrz	break
			and	a,FLG_LIGHT
			mv	[x+MAP_WIDTH],a
			{
				cmp	a,MARK_DOOR
				jrnz	break
				mv	(work),(current_room)
				call	MaskRoom
			}
		}
	}
	ret
 }



;------------------------------------------------
;	K
;------------------------------------------------
VisitRoom:
 {
	{
		cmp	(turn_end),0
		jrnz	break
		ret
	}
	{
		cmp	(back_mark),MARK_DOOR	;hA
		jrz	break
		ret
	}
	mvw	(work),(my_x)
	call	GetRoomNo			;ԍ
	mv	(current_room),(work)		;݂̕

	call	LightRoom			;CgAbv
	{
		cmp	(m_house_flg),0		;X^[nEX
		jrz	break
		cmp	(m_wakeup),1		;N
		jrz	break

		cmp	(current_room),(m_house_room)
		jrnz	break
		call	Print_HOUSE		;bZ[W
		mv	(m_wakeup),1		;X^[ĂɋN
		call	WakeUpMonster
	}
	ret
 }



;------------------------------------------------
;	W畔ԍ߂
;	in:	(work).w	XYW
;	out:	(work)		0-9:ԍ@-1:ʘH
;------------------------------------------------
GetRoomNo:
 {
	pushu_reg
	mv	il,0
	mv	x,RoomData
	{
		{
			mv	a,[x]
			test	a,R_ROOM|R_HOUSE
			jrz	break

			mv	a,[x+1]		;_Ɛ̔
			mv	(work+5),a
			mv	(work+6),[x+2]
			sub	(work+6),a	;X_WIDTH

			mv	a,(work)
			sub	a,(work+5)	;m-e<w
			cmp	(work+6),a
			jrc	break

			mv	a,[x+3]
			mv	(work+5),a
			mv	(work+6),[x+4]
			sub	(work+6),a	;Y_WIDTH

			mv	a,(work+1)
			sub	a,(work+5)	;m-e<w
			cmp	(work+6),a
			jrc	break
			mv	(work),il
			popu_reg
			ret
		}
		inc	il
		mv	a,16
		add	x,a
		jr	continue
	}
	mv	(work),-1
	popu_reg
	ret
 }



;------------------------------------------------
;	CgAbv
;	in:	(work).b	ԍ
;------------------------------------------------
LightRoom:
 {
	mv	(mask_flg),0
	call	GetRoomPointer

	mvw	(work+0),[y+1]
	mvw	(work+2),[y+3]
	mv	(work+6),0
	call	LightOrMaskFloor
	ret
 }



;------------------------------------------------
;	}XN
;	in:	(work).b	ԍ
;------------------------------------------------
MaskRoom:
 {
	{
		cmp	(mask_flg),0
		jrz	break
		ret
	}
	mv	(mask_flg),1
	mv	(current_room),-1	;o
 }



;------------------------------------------------
;	}XN
;	in:	(work).b	ԍ
;------------------------------------------------
MaskFloor:
 {
	call	GetRoomPointer

	mvw	(work+0),[y+1]
	inc	(work+0)
	dec	(work+1)
	mvw	(work+2),[y+3]
	inc	(work+2)
	dec	(work+3)
	mv	(work+6),1
 }



;------------------------------------------------
;	_A
;in:	(work).w	Xn_I_
;	(work+2).w	Yn_I_
;	(work+6)	0=_@1=
;------------------------------------------------
LightOrMaskFloor:
 {
	pushu_reg
	call	GetDrawMapPos

	mv	a,(work+1)
	sub	a,(work+0)	;XI_-n_
	inc	a
	mv	(work+4),a	;JEg

	mv	a,(work+3)
	sub	a,(work+2)	;YI_-n_
	inc	a
	mv	(work+5),a	;cJEg
	{
		mv	il,(work+4)
		{
			mv	a,[y++]
			or	a,FLG_DARK
			{
				cmp	(work+6),0
				jrnz	break
				and	a,FLG_LIGHT
			}
			mv	[y-1],a

			dec	il
			jrnz	continue
		}
		mv	a,MAP_WIDTH
		sub	a,(work+4)
		add	y,a
		dec	(work+5)
		jrnz	continue
	}
	popu_reg
	ret
 }



;------------------------------------------------
;	gbv̔
;------------------------------------------------
CheckTrap:
 {
	{
		cmp	(turn_end),1	;ʏ^[̂
		jrz	break
		ret
	}
	mv	a,(back_mark)
	{
		test	a,FLG_TRAP
		jrnz	break
		test	(key),KEY_SPACE	;SPACEŃXLbv
		jrz	break
		ret
	}
	and	a,1101_1111b
	{
		cmp	a,MARK_TRAP
		jrz	break
		ret
	}
	mv	(back_mark),a

	mv	(sound_no),3
	{
		call	Rnd
		and	(vrnd),3
		jrnz	break

		call	Trap_TELEPO	;ol
		ret
	}
	{
		call	Rnd
		and	(vrnd),3
		jrnz	break

		call	Trap_STEELTRAP	;goT~
		ret
	}
	{
		call	Rnd
		and	(vrnd),3
		jrnz	break

		call	Trap_HARAHERI	;
		ret
	}
	{
		call	Rnd
		and	(vrnd),3
		jrnz	break

		call	Trap_BOMB	;n
		ret
	}
	{
		call	Rnd
		and	(vrnd),7
		jrnz	break

		call	Se
		call	Se

		call	Print_HOLE	;Ƃ
		and	(hp),1111_1110b	;HP 1/2
		{
			ror	(hp)
			jrnz	break
			mv	(game_status),GO_TRAP
		}
;		call	SetNextFloor
		inc	(floor)
		mv	(p_status),ST_NOMAL
		call	Print_STAT
		call	Print_FLOOR
		call	Print_HP

		pops	i
		jp	Start
	}
	{
		call	Rnd
		and	(vrnd),3
		jrnz	break

		call	Trap_SIREN	;TC
		ret
	}
	call	Trap_DONTMOVE		;
	ret
 }

	;Tu@n
Trap_BOMB:
 {
	call	Se
	call	Se

	rc
	shr	(hp)
	inc	(hp)
	call	Print_BOMB
	ret
 }

	;Tu@goT~
Trap_STEELTRAP:
 {
	call	Se
	call	Se

	call	rnd
	and	(vrnd),3
	add	(vrnd),2
	mv	(stop_count),(vrnd)
	call	Print_STEEL
	{
		call	Inkey
		call	Inkey2
		call	ClearScreen
		call	Monster			;X^[
		call	HouseMons		;X^[nEX
		{
			cmp	(return_flg),0
			jrz	break
			call	Monster		;X^[ړ{
			call	HouseMons
		}
		call	MapToScreen		;XN[ɕ`
		call	DispScreen

		mv	(turn_end),0
		or	(key),(key2)
		test	(key),1111_1111b
		jrz	continue

		mv	(turn_end),1
		dec	(stop_count)
		jrnz	continue
	}
	ret
 }

	;Tu@e|[g
Trap_TELEPO:
 {
	call	Se
	call	Se

	call	Print_TELEPO

	call	ErasePlayer
	mv	(work),(current_room)
	call	MaskRoom

	call	InitPosition
	call	PutPlayer
	ret
 }

	;Tu@
Trap_HARAHERI:
 {
	call	Se
	call	Se

	rc
	shr	(hung)	;1/2
	inc	(hung)

	call	Print_HARAHERI
	ret
 }

	;Tu@TC
Trap_SIREN:
 {
	call	Se
	call	Se

	call	WakeUpAllMons
	call	Print_WAKEUP
	ret
 }

	;Tu@gbv
Trap_DONTMOVE:
 {
	call	Print_DONTMOVE
	ret
 }



;------------------------------------------------
;	ACe̔
;------------------------------------------------
CheckItem:
 {
	{
		cmp	(turn_end),0
		jrnz	break
		ret
	}
	{
		test	(key),KEY_SPACE	;spaceŃXLbv
		jrz	break
		ret
	}
	mv	a,(back_mark)
	and	a,1101_1111b

	mv	(sound_no),2
	{
		cmp	a,MARK_SCROLL
		jrnz	break
		mv	(back_mark),MARK_FLOOR
		call	Use_SCROLL	;
		ret
	}
	{
		cmp	a,MARK_GOLD
		jrnz	break
		mv	(back_mark),MARK_FLOOR
		call	Use_GOLD	;
		ret
	}
	{
		cmp	a,MARK_POTION
		jrnz	break
		mv	(back_mark),MARK_FLOOR
		{
			call	Rnd
			and	(vrnd),7
			jrz	break
			call	Use_POTION	;
			ret
		}
		call	Use_POISON		;
		ret
	}
	{
		cmp	a,MARK_WEAPON
		jrnz	break
		mv	(back_mark),MARK_FLOOR
		call	Use_WEAPON	;
		ret
	}
	{
		cmp	a,MARK_ARMOR
		jrnz	break
		mv	(back_mark),MARK_FLOOR
		call	Use_ARMOR	;h
		ret
	}
	{
		cmp	a,MARK_FOOD
		jrnz	break
		mv	(back_mark),MARK_FLOOR
		call	Use_FOOD	;H
	}
	{
		cmp	a,MARK_RING
		jrnz	break
		mv	(back_mark),MARK_FLOOR
		call	Use_RING	;w
	}
	{
		cmp	a,MARK_STAIR	;Ki
		jrnz	break

		call	Se
		call	Print_STAIR
		call	SetNextFloor
		call	Print_FLOOR

		pops	i
		jp	Start
	}
	{
		cmp	a,MARK_AMULET	;
		jrnz	break
		mv	(back_mark),MARK_FLOOR

		call	Se
		call	Print_GETAMURET
		mv	(return_flg),1
	}
	ret
 }



	;Tu@H
Use_FOOD:
 {
	call	Se
	{
		cmp	(hung_max),(hung)	;ԂȂ+5%
		jrnz	break
		add	(hung_max),5
		mv	(hung),(hung_max)
		call	Print_FOOD1
		ret
	}
	add	(hung),50			;+50%
	{
		cmp	(hung_max),(hung)
		jrnc	break
		mv	(hung),(hung_max)
	}
	{
		call	Rnd
		and	(vrnd),3
		jrz	break
		call	Print_FOOD1		;p
		ret
	}
	{
		call	Rnd
		mv	a,(vrnd)
		and	a,3
		inc	a
		sub	(hp),a			;1..4
		jrnc	break
		mv	(hp),0
	}
	{
		cmp	(hp),0
		jrnz	break
		mv	(game_status),GO_PAN
	}
	call	Print_FOOD2			;p
	ret
 }



	;Tu@
Use_WEAPON:
 {
	call	Se
	{
		call	Rnd		;|𑕔
		and	(vrnd),1
		jrnz	break
		call	Rnd
		mv	a,(vrnd)	;5..8
		and	a,3
		add	a,5
		add	(arrow),a
		{
			cmp	(arrow),40+1	;ő40{
			jrc	break
			mv	(arrow),40
		}
		call	Print_ARROW	;bZ[W
		ret
	}
	call	Rnd
	mv	a,(vrnd)
	and	a,7
	{
		cmp	(floor),5+1	;tA1`5
		jrnc	break

		mv	x,StrRatio
		add	x,a
		mv	a,[x]
		jr	_next
	}
	{
		cmp	(floor),12+1	;tA6`12
		jrnc	break

		mv	x,StrRatio+8
		add	x,a
		mv	a,[x]
		jr	_next
	}
	{				;tA13`
		mv	x,StrRatio+16
		add	x,a
		mv	a,[x]
	}
_next:
	mv	(work),a
	inc	a
	add	a,a
	{
		cmp	(str),a
		jrc	break
		call	Print_WEAPON2	;Ȃ
		ret
	}
	mv	(str),a
	call	Print_WEAPON
	ret
 }



	;Tu@h
Use_ARMOR:
 {
	call	Se

	call	Rnd
	mv	a,(vrnd)
	and	a,7
	{
		cmp	(floor),5+1	;tA1`5
		jrnc	break

		mv	x,StrRatio
		add	x,a
		mv	a,[x]
		jr	_next
	}
	{
		cmp	(floor),12+1	;tA6`12
		jrnc	break

		mv	x,StrRatio+8
		add	x,a
		mv	a,[x]
		jr	_next
	}
	{				;tA13`
		mv	x,StrRatio+16
		add	x,a
		mv	a,[x]
	}
_next:
	mv	(work),a
	inc	a
	add	a,a
	{
		cmp	(arm),a
		jrc	break
		call	Print_ARMOR2	;Ȃ
		ret
	}
	mv	(arm),a
	call	Print_ARMOR
	ret
 }



	;Tu@
Use_POTION:
 {
	call	Se
	{
		cmp	(hp),(hp_max)
		jrnz	break
		inc	(hp_max)	;HPőlPto
		{
			cmp	(hp_max),99+1
			jrc	break
			mv	(hp_max),99
		}
		jr	_next
	}
	{
		call	Rnd
		and	(vrnd),3	;1/4
		jrnz	break

		mv	(hp),(hp_max)	;S
		jr	_next
	}
	add	(hp),25			;25|Cg
	{
		cmp	(hp_max),(hp)
		jrnc	break
		mv	(hp),(hp_max)
	}
_next:
	{
		add	(hung),5		;x+5%
		cmp	(hung_max),(hung)
		jrnc	break
		mv	(hung),(hung_max)
	}
	call	Print_POTION
	ret
 }



	;Tu@Ŗ
Use_POISON:
 {
	inc	(sound_no)
	call	Se
	{
		call	Rnd
		mv	a,(vrnd)	;1..4
		and	a,3
		inc	a
		sub	(hp),a
		jrnc	break
		mv	(hp),0
	}
	{
		cmp	(hp),0
		jrnz	break
		mv	(game_status),GO_POISON
	}
	{
		add	(hung),5	;x+5%
		cmp	(hung_max),(hung)
		jrnc	break
		mv	(hung),(hung_max)
	}
	call	Print_POISON
	ret
 }



	;Tu@
Use_GOLD:
 {
	call	Se

	call	Rnd
	and	(vrnd),7
	inc	(vrnd)
	mv	(vwork+1),0
	mv	(vwork),(vrnd)

	mv	il,2
	adcl	(gold),(vwork)

	call	Print_KINKAI	;bZ[W\
	ret
 }



	;Tu@
Use_SCROLL:
 {
	call	Se
	{
		call	Rnd
		and	(vrnd),7
		jrnz	break

		call	Print_SCRL3	;NȂ
		ret
	}
	{
		call	Rnd
		and	(vrnd),1	;1/2
		jrnz	break

		mv	il,4
		{
			mvw	(work+5),MARK_TRAP|FLG_DARK|FLG_TRAP
			call	PutItem_sub
			dec	il
			jrnz	continue
		}
		call	Print_SCRL2	;㩂𑝂₷
		ret
	}
	mv	x,FieldMap
	mv	i,MAP_WIDTH*MAP_HEIGHT
	{
		mv	a,[x++]
		{
			test	a,FLG_TRAP
			jrz	break
			and	a,1101_1111b
			mv	[x-1],a
		}
		dec	i
		jrnz	continue
	}
	call	Print_SCRL1	;㩔
	ret
 }



	;Tu@w
Use_RING:
 {
	call	Se

	mv	(revival_flg),1
	call	Print_RING
	ret
 }



;------------------------------------------------
;	eACe̔zu
;------------------------------------------------
PutItem:
 {
	call	Rnd
	and	(vrnd),3
	add	(vrnd),5	;5..8
	mv	il,(vrnd)
	{
		{
			call	Rnd
			and	(vrnd),3
			jrnz	break
			mv	(work+5),MARK_POTION|FLG_DARK	;
			call	PutItem_sub
			jr	_next
		}
		{
			call	Rnd
			and	(vrnd),3
			jrnz	break
			mv	(work+5),MARK_WEAPON|FLG_DARK	;
			call	PutItem_sub
			jr	_next
		}
		{
			call	Rnd
			and	(vrnd),7
			jrnz	break
			mv	(work+5),MARK_ARMOR|FLG_DARK	;h
			call	PutItem_sub
			jr	_next
		}
		{
			call	Rnd
			and	(vrnd),15
			jrnz	break
			mv	(work+5),MARK_FOOD|FLG_DARK	;H
			call	PutItem_sub
			jr	_next
		}
		{
			cmp	(floor),2+1			;3Kȍ~
			jrc	break
			call	Rnd
			and	(vrnd),3
			jrnz	break
			mv	(work+5),MARK_SCROLL|FLG_DARK	;
			call	PutItem_sub
			jr	_next
		}
		{
			cmp	(floor),4+1			;4Kȍ~
			jrc	break
			call	Rnd
			and	(vrnd),3
			jrnz	break
			mv	(work+5),MARK_RING|FLG_DARK	;w
			call	PutItem_sub
			jr	_next
		}
		{
			mv	(work+5),MARK_GOLD|FLG_DARK	;
			call	PutItem_sub
		}
_next:
		dec	il
		jrnz	continue
	}
	{
		mv	a,(floor)
		and	a,1111_1100b		;4KƂɕKH
		jrz	break
		mv	(work+5),MARK_FOOD|FLG_DARK	;H
		call	PutItem_sub
	}
	{
		cmp	(floor),1		;1Kɂ͕KAhzu
		jrnz	break
		mv	(work+5),MARK_WEAPON|FLG_DARK
		call	PutItem_sub
		mv	(work+5),MARK_ARMOR|FLG_DARK
		call	PutItem_sub
	}
	{
		cmp	(floor),DEF_AMULET_LV
		jrc	break
		mv	(work+5),MARK_AMULET|FLG_DARK
		call	PutItem_sub		;o
	}
	mv	(work+5),MARK_STAIR|FLG_DARK	;Ki
	call	PutItem_sub
	ret
 }



;------------------------------------------------
;	̊Kݒ
;------------------------------------------------
SetNextFloor:
 {
	mv	(p_status),ST_NOMAL	;Xe[^Xُ
	call	Print_STAT
	{
		cmp	(return_flg),0
		jrnz	break

		inc	(floor)
		ret
	}
	{
		dec	(floor)
		jrz	break
		ret
	}
	mv	(game_status),GO_CLEAR	;Q[NA
	ret
 }



;------------------------------------------------
;	gbvzu
;------------------------------------------------
PutTrap:
 {
	{
		cmp	(floor),2+1
		jrnc	break
		ret
	}
	{
		cmp	(floor),12+1
		jrnc	break
		mv	il,2
		jr	_next
	}
	mv	il,4
_next:
	call	Rnd
	mv	a,(vrnd)
	and	a,2
	add	il,a
	{
		mv	(work+5),MARK_TRAP|FLG_TRAP|FLG_DARK	;gbv
		call	PutItem_sub

		dec	il
		jrnz	continue
	}
	ret
 }



;------------------------------------------------
;	ACezu
;	in:	(work+5).b	ACe
;------------------------------------------------
PutItem_sub:
 {
	pushu_reg
_retry:
	call	MixRoomNum		;ԍ̃Vbt

	mv	x,RoomNumData
	{
		mv	(work),[x++]	;߂
		call	GetRoomPointer

		mv	a,[y]
		test	a,R_ROOM
		jrz	continue
	}
	mvw	(work+0),[y+1]		;Xn_,I_
	mvw	(work+2),[y+3]		;Yn_,I_
	inc	(work)
	inc	(work+2)
	{
		call	Rnd
		and	(vrnd),15
		mv	a,(work)
		add	(vrnd),a
		cmp	(vrnd),(work+1)	;X
		jrnc	continue
	}
	mv	(work),(vrnd)
	{
		call	Rnd
		and	(vrnd),7
		mv	a,(work+2)
		add	(vrnd),a
		cmp	(vrnd),(work+3)	;Y
		jrnc	continue
	}
	mv	(work+1),(vrnd)
	call	GetMapPos
	mv	a,[x]
	cmp	a,MARK_FLOOR|FLG_DARK	;
	jrnz	_retry

	mv	a,(work+5)
	mv	[x],a
	popu_reg
	ret
 }



;------------------------------------------------
;	X^[ɍU
;	in:	a		Lԍ
;		(work).w	XYW
;------------------------------------------------
Attack_M:
 {
	pushu_reg
	mvw	[--u],(work)
	call	PutPlayer
	mvw	(work),[u++]

	call	Search_MONSTER
	pushu	x

	mv	(m_status),ST_NOMAL	;ڂo܂

	mv	a,1			;bZ[WtO
	mv	(sound_no),0
	{
		call	Rnd
		and	(vrnd),3
		jrz	break

		call	Rnd
		and	(vrnd),2
		mv	a,(str)		;(base_str+str)-m_arm
		add	a,(base_str)
		add	a,(vrnd)	;+ 0 or 2
		{
			sub	a,(m_arm)
			jrnc	break
			mv	a,1
		}
		{
			cmp	a,0
			jrnz	break
			mv	a,1
		}
		sub	(m_hp),a

		mv	a,0		;bZ[WtO
		mv	(sound_no),2
	}
	call	Se
	call	Print_ATTACK_P		;UbZ[W

	call	MakeNewMonster		;|VX^[̍쐬

	popu	x
	mv	il,11
	mvl	[x+0],(m_name)

	call	ErasePlayer
	mv	(turn_end),2		;U^[
	popu_reg
	ret
 }



	;Tu@ǂ̃X^[ɍUH
	;in:	a		Lԍ
	;	(work).w	XYW
	;out:	x		X^[̃AhX
	;	(m_name)...	ep[^
Search_MONSTER:
 {
	mv	x,MonBuf
	mv	il,16
	{
		{
			mvw	(work+5),[x+1]
			cmp	(work+5),(work)		;X
			jrnz	break
			cmp	(work+6),(work+1)	;Y
			jrnz	break

			mv	(work+5),[x]		;Lԍ
			and	(work+5),FLG_LIGHT
			cmp	(work+5),a
			jrnz	break

			mv	il,11
			mvl	(m_name),[x+0]
			ret
		}
		add	x,il
		jr	continue
	}
 }



;------------------------------------------------
;	xAbv
;------------------------------------------------
LevelUp:
 {
	{
		cmp	(level),20	;ő Lv20
		jrc	break
		ret
	}
	mv	ba,(expe)
	mv	il,(m_expe)
	add	ba,i
	mv	(expe),ba
	{
		cmpw	(expe),(next_expe)
		jrnc	break
		ret
	}
	mvw	(expe),0
	mv	ba,(next_expe)
	add	ba,ba
	mv	(next_expe),ba	;̃x܂

	inc	(level)		;xAbv

	call	Rnd
	mv	a,(vrnd)
	and	a,3
	inc	a
	add	(hp_max),a	;HP 1..4
	{
		cmp	(hp_max),99+1	;ő99
		jrc	break
		mv	(hp_max),99
	}
	mv	(hp),(hp_max)		;HP
	add	(base_str),2		;STR +2
	add	(base_arm),2		;ARM +2
	mv	(p_status),ST_NOMAL	;Xe[^X

	mv	(sound_no),2
	call	Se

	call	Print_LEVELUP	;xAbṽbZ[W
	ret
 }



;------------------------------------------------
;	x_E
;------------------------------------------------
LevelDown:
 {
	{
		cmp	(level),6
		jrnc	break
		ret
	}
	mvw	(work),(next_expe)	;̌olZbg
	rc
	shr	(work+1)
	shr	(work)
	mvw	(next_expe),(work)

	mvw	(expe),(next_expe)	;olZbg
	dec	(expe)

	sub	(base_str),2		;STR
	sub	(base_arm),2		;ARM

	sub	(hp_max),3		;HP
	{
		cmp	(hp),(hp_max)
		jrc	break
		mv	(hp),(hp_max)
	}
	dec	(level)			;x
	call	Print_LEVDOWN		;bZ[W
	ret
 }



;------------------------------------------------
;	}bvXN[֕`
;------------------------------------------------
MapToScreen:
 {
	pushu_reg
	mvw	(work),(scrn_x)
	call	GetMapPos

	mv	(SI),1
	{
		mv	(DI),0
		{
			mv	a,[x++]
			{
				test	a,FLG_DARK	;
				jrz	break
				mv	a,0
			}
			{
				test	a,FLG_HIDEDOOR	;B
				jrz	break
				and	a,1011_1111b
			}
			{
				test	a,FLG_TRAP	;gbv
				jrz	break
				mv	a,MARK_FLOOR	;
			}
			cmp	a,0
			jrz	_next

			pushu	x
			mv	x,ChrData
			pushu	a
			popu	il
			add	i,i
			add	i,i
			add	i,a	;*5
			add	x,i

			mv	y,ScreenBuf
			mv	a,(SI)
			mv	b,a
			mv	a,(DI)
			call	PutChr

			popu	x
_next:
			add	(DI),6
			cmp	(DI),120
			jrnz	continue
		}
		mv	a,MAP_WIDTH-20
		add	x,a

		mv	(DI),0
		add	(SI),6
		cmp	(SI),31
		jrnz	continue
	}
	popu_reg
	ret
 }



	;Tu@}bṽAhX߂
	;in:	(work).w	XYW
GetMapPos:
 {
	pushu	i
	pushu	a

	mv	x,FieldMap
	mv	il,(work+1)
	add	i,i
	add	i,i
	add	i,i
	add	i,i
	add	i,i
	add	i,i	;*64
	add	x,i
	mv	a,(work)
	add	x,a

	popu	a
	popu	i
	ret
 }



	include		DUNGEON.S	;_W
	include		MONSTER.S	;X^[
	include		MESSAGE.S	;bZ[W

	include		VER.S		;o[W

	include		LIB.S		;ėpCu
	include		SCORE.S		;XRA

	include		DATA.S		;f[^
	include		WORK.S		;[N



	end
